void auth_fn(const char *server, const char *share, char *workgroup, int wgmaxlen, char *username, int unmaxlen,	char *password, int pwmaxlen)
{
	strncpy(username, Login, unmaxlen);
	strncpy(password, Password, pwmaxlen);
}

void config_init(void)
{
	GtkWidget *Dialog;
	GError *Error;
	gchar **Key_Groups;
	gint Response;
	guint Num_Groups;
	guint i;
	gboolean Is_Loaded;

	Error = NULL;
	InitFile = g_key_file_new();
	Is_Loaded = g_key_file_load_from_file(InitFile, Config_file_name, G_KEY_FILE_KEEP_COMMENTS, NULL);
	if (!Is_Loaded){
		Is_Loaded = g_key_file_load_from_file(InitFile, "/usr/share/g2sc/g2sc.conf", G_KEY_FILE_KEEP_COMMENTS, &Error);
	}
	if (Is_Loaded){		
		Login = g_key_file_get_string(InitFile, "Global", "Login", NULL);
		Password = g_key_file_get_string(InitFile, "Global", "Password", NULL);
		Save_Folder = g_key_file_get_string(InitFile, "Searcher", "Save_Folder", NULL);
		System_Filename_Encoding = g_key_file_get_string(InitFile, "Global", "Sys_Encoding", NULL);
		Samba_Filename_Encoding = g_key_file_get_string(InitFile, "Global", "Smb_Encoding", NULL);
		
		Key_Groups = g_key_file_get_groups(InitFile, &Num_Groups);
		for (i=5;i<=Num_Groups;i++){
			gtk_combo_box_insert_text(GTK_COMBO_BOX(Selecter), i-5, Key_Groups[i-1]);
			
			Masks[i-5].Name = Key_Groups[i-1];
			Masks[i-5].Extensions = g_key_file_get_string(InitFile, Key_Groups[i-1], "Extensions", NULL);
			Masks[i-5].MinSize = g_key_file_get_string(InitFile, Key_Groups[i-1], "MinSize", NULL);
			Masks[i-5].MaxSize = g_key_file_get_string(InitFile, Key_Groups[i-1], "MaxSize", NULL);
			Masks[i-5].Metric = g_key_file_get_string(InitFile, Key_Groups[i-1], "Metric", NULL);
			Masks[i-5].Shares = g_key_file_get_string(InitFile, Key_Groups[i-1], "Shares", NULL); 
		}
	}
	else{
		Dialog = gtk_message_dialog_new(GTK_WINDOW(Main_Window), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "Can't open configuration file");
		gtk_message_dialog_format_secondary_text(GTK_MESSAGE_DIALOG(Dialog),  "Error No:%d, %s", Error->code, Error->message);
		gdk_threads_enter();
		Response = gtk_dialog_run(GTK_DIALOG(Dialog));
		gtk_widget_destroy(Dialog);
		gdk_flush();
		gdk_threads_leave();
		g_error_free(Error);
	}
}

void config_save(void)
{
	guint Size;
	gchar *Keys;
	FILE *File;
	 
	Keys = g_key_file_to_data(InitFile, &Size, NULL);
	File = fopen(Config_file_name, "w");
	fwrite(Keys, Size, 1, File);
	fclose(File);
}

void Set_Active_Mask(gint Item)
{
	gtk_combo_box_set_active(GTK_COMBO_BOX(Mask_Name), Item); 
	gtk_entry_set_text(GTK_ENTRY(Mask_Extensions), Masks[Item].Extensions);
	gtk_entry_set_text(GTK_ENTRY(Mask_MinSize), Masks[Item].MinSize);
	gtk_entry_set_text(GTK_ENTRY(Mask_MaxSize), Masks[Item].MaxSize);
	gtk_entry_set_text(GTK_ENTRY(Mask_Metric), Masks[Item].Metric);
	gtk_entry_set_text(GTK_ENTRY(Mask_Shares), Masks[Item].Shares);
}

void Add_Book_Page(GtkWidget *Target, GtkWidget *Source, gchar *Label_Text)
{
	GtkWidget *Label;

	Label = gtk_label_new(Label_Text);
	gtk_notebook_append_page(GTK_NOTEBOOK(Target), Source, Label);
}

void Add_Download(gchar *Path, gulong Size)
{
	GtkTreeIter Download_Iterator;

	gtk_tree_store_append(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Download_Iterator, NULL);
	gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Download_Iterator, 0, Download_Icon[0], 1, "Waiting", 3, Path, 4, Size, -1);
}

void Scan_Downloads(gpointer Data)
{

}

gpointer Share_Open(gpointer Rect)
{
GtkTreeIter Parent_Item, New_Item;
GtkTreePath *TreePath;
gchar *Utf8_Entry_Name, *Encoded_Entry_Name;
gchar *Encoded_Share_Path;
gchar *Utf8_Share_Path, Open_Share[1024];
gint Struct_Size, Entry_Type;
gint Share_Type, Share_ID;
gulong Entry_Size;
gboolean Check_Repeat;
struct stat statistic;
struct smbc_dirent *Pack;

	Check_Repeat = FALSE;
	Encoded_Share_Path = ((struct Zap *)Rect)->Pth;
	Parent_Item = ((struct Zap *)Rect)->Iter;
	Share_Type = ((struct Zap *)Rect)->Type;
	
	gdk_threads_enter();
	gtk_label_set_text(GTK_LABEL(Browser_Status), "Opening...");
	gdk_flush();
	gdk_threads_leave();
		
	Share_ID = smbc_opendir(Encoded_Share_Path);
	if (Share_ID > 0 ){
		Pack = smbc_readdir(Share_ID);	
		while (Pack != NULL){
			Struct_Size = Pack->dirlen;
			Entry_Type = Pack->smbc_type;
			Encoded_Entry_Name = Pack->name;
			if ((strcmp(Encoded_Entry_Name, "..") == 0) && (Check_Repeat == TRUE)) break;
			if (strcmp(Encoded_Entry_Name, "..") == 0) Check_Repeat = TRUE;
			Utf8_Entry_Name = g_convert(Encoded_Entry_Name, -1, "UTF-8", Samba_Filename_Encoding, NULL, NULL, NULL);
			gtk_tree_model_get(gtk_tree_view_get_model(GTK_TREE_VIEW(Browse_Tree)), &Parent_Item, 3, &Utf8_Share_Path, -1);
			Entry_Size = 0;
			if (Share_Type == 1){
				sprintf(Open_Share, "smb://%s/", Encoded_Entry_Name);
				Utf8_Share_Path = g_convert(Open_Share, -1, "UTF-8", Samba_Filename_Encoding, NULL, NULL, NULL);
			}
			else{
				if (Entry_Type == 8){
					sprintf(Open_Share, "%s%s", Encoded_Share_Path, Encoded_Entry_Name);
					Utf8_Share_Path = g_convert(Open_Share, -1, "UTF-8", Samba_Filename_Encoding, NULL, NULL, NULL);
					smbc_stat(Open_Share, &statistic);
					Entry_Size = statistic.st_size;
				}
				else{
					sprintf(Open_Share, "%s%s/", Encoded_Share_Path, Encoded_Entry_Name);
					Utf8_Share_Path = g_convert(Open_Share, -1, "UTF-8", Samba_Filename_Encoding, NULL, NULL, NULL);
				}
			}
			if ((strcmp(Encoded_Entry_Name, "..") != 0) && (strcmp(Encoded_Entry_Name, ".") != 0) && (Entry_Type != 6) && (Entry_Type != 4)){
				gdk_threads_enter();
				gtk_tree_store_append(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Browse_Tree))), &New_Item, &Parent_Item);
				gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Browse_Tree))), &New_Item, 0, Browse_Icon[Entry_Type], 1, Utf8_Entry_Name, 2, Entry_Size, 3, Utf8_Share_Path, 4, Entry_Type,- 1);
				gdk_flush();
				gdk_threads_leave();
			}
			Pack = smbc_readdir(Share_ID);
		}
		smbc_closedir(Share_ID);
		TreePath = gtk_tree_model_get_path(gtk_tree_view_get_model(GTK_TREE_VIEW(Browse_Tree)), &Parent_Item); 
		gdk_threads_enter();
	 	gtk_tree_view_expand_row(GTK_TREE_VIEW(Browse_Tree), TreePath, FALSE);
		gtk_tree_view_scroll_to_cell(GTK_TREE_VIEW(Browse_Tree), TreePath, NULL, TRUE, 0.5, 0.5);
		gdk_flush();
		gdk_threads_leave();
		gtk_tree_path_free(TreePath); 
	}
	gdk_threads_enter();
	gtk_label_set_text(GTK_LABEL(Browser_Status), "Idle");
	gdk_flush();
	gdk_threads_leave();
	
	return NULL;
}

gpointer Search_Iteration(gchar *Path, gpointer Data)
{
	GtkTreeIter New_Item;

	gchar *Share_Name, *Share_Path, Open_Share[1024];
	gchar Buffer[16384], Size[32];
	gchar *Entry_Name, *Entry_Ptr;
	gint Share_ID, Buffer_Size;
	gint Struct_Size, Entry_Type;
	gulong Entry_Size;
	struct stat statistic;
	
	if (Search_Flag == FALSE){
		gdk_threads_enter();
		gtk_label_set_text(GTK_LABEL(Searcher_Status), "Idle");
		gdk_flush();
		gdk_threads_leave();
		g_thread_exit(NULL);
	}
	gdk_threads_enter();
	gtk_label_set_text(GTK_LABEL(Searcher_Status), g_convert(Path, -1, "utf8", Samba_Filename_Encoding, NULL, NULL, NULL));
	gdk_flush();
	gdk_threads_leave();
	if ((Share_ID = smbc_opendir(Path)) >= 0 ){
		Entry_Ptr = (gchar*)Buffer;
		Buffer_Size = smbc_getdents(Share_ID, (struct smbc_dirent *)Buffer, sizeof(Buffer));
		while (Buffer_Size > 0) {
			Struct_Size = ((struct smbc_dirent *)Entry_Ptr)->dirlen;
			Entry_Type = ((struct smbc_dirent *)Entry_Ptr)->smbc_type;
			Entry_Name = ((struct smbc_dirent *)Entry_Ptr)->name;
			if (Entry_Type == 8){
				Share_Name = g_convert(Entry_Name, -1, "utf8", Samba_Filename_Encoding, NULL, NULL, NULL);
				Share_Path = g_convert(Path, -1, "utf8", Samba_Filename_Encoding, NULL, NULL, NULL);
				sprintf(Open_Share, "%s%s", Path, Entry_Name); 
				smbc_stat(Open_Share, &statistic);
				Entry_Size = statistic.st_size;
				sprintf(Size, "%li", Entry_Size);
				if (Filter("FILTER_BY_EXT", Share_Name) && Filter("FILTER_BY_SIZE", Size)){
					sprintf(Open_Share, "%s%s", Share_Path, Share_Name); 
					gdk_threads_enter();
					gtk_list_store_append(Data, &New_Item);
					gtk_list_store_set(Data, &New_Item, 0, GTK_STOCK_OK, 1, Share_Name, 2, Entry_Size, 3, Open_Share, 4, Entry_Type, -1);
					gdk_flush();
					gdk_threads_leave();
				}
			}
			else{
				if (Entry_Type == 2){
					sprintf(Open_Share, "smb://%s/", Entry_Name);
				}
				else{
					sprintf(Open_Share, "%s%s/", Path, Entry_Name);
				}
				if (((strcmp(Entry_Name, "..") != 0) && (strcmp(Entry_Name, ".") != 0)) && ((Entry_Type != 4) && (Entry_Type != 9))){
					if ((Entry_Type !=3) || (Filter("FILTER_BY_SHARE", Entry_Name))) Search_Iteration(Open_Share, Data);
				}
			}
			Entry_Ptr = Entry_Ptr + Struct_Size;
			Buffer_Size = Buffer_Size - Struct_Size;
		}
		smbc_closedir(Share_ID);
	}
	return NULL;
}

gpointer Search_Files(gpointer Data)
{
	Search_Iteration("smb://", Data);
	gdk_threads_enter();
	gtk_label_set_text(GTK_LABEL(Searcher_Status), "Idle");
	gdk_flush();
	gdk_threads_leave();
	return NULL;
}

gpointer Download_Files(gpointer data)
{
	GtkTreeIter Iterator;
	GtkWidget *Dialog;
	gboolean Is_Iter;
	gint rh, k, rbyte;
	gchar *Utf8_Path, *System_Encoded_Path, *Samba_Encoded_Path, *Encoded_Name, File_Path[128];
	gchar rbuff[8192];
	glong count, Size;
	gint Response;
	FILE *wh;
	div_t procent;
	struct statfs hdd;
	struct stat fstat;

	Is_Iter = gtk_tree_model_get_iter_first(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree)), &Iterator);
	while (Is_Iter){
		count = 0;
		k = 1;
		gtk_tree_model_get(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree)), &Iterator, 3, &Utf8_Path, 4, &Size, -1);
		procent = div(Size, 100);
		System_Encoded_Path = g_convert(Utf8_Path, -1, System_Filename_Encoding, "UTF-8", NULL, NULL, NULL);		
		Samba_Encoded_Path = g_convert(Utf8_Path, -1, Samba_Filename_Encoding, "UTF-8", NULL, NULL, NULL);
		Encoded_Name = strrchr(System_Encoded_Path, '/');
		if (Save_Folder != NULL) sprintf(File_Path, "%s%s", Save_Folder, Encoded_Name);
			else sprintf(File_Path, "%s", Encoded_Name+1);
		if ((wh = fopen(File_Path, "r")) != NULL){
			fclose(wh);
			stat(File_Path, &fstat);
			count = fstat.st_size;
			Dialog = gtk_message_dialog_new(GTK_WINDOW(Main_Window), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_QUESTION, GTK_BUTTONS_OK_CANCEL, "File '%s' exist", g_filename_to_utf8(Encoded_Name+1, -1, NULL, NULL, NULL));
			gtk_dialog_add_button(GTK_DIALOG(Dialog), GTK_STOCK_ADD, GTK_RESPONSE_APPLY);
			gtk_message_dialog_format_secondary_text(GTK_MESSAGE_DIALOG(Dialog),  "File size: %ld \nNew file size: %ld\nOverwrite?" , count, Size);
			gdk_threads_enter();
			Response = gtk_dialog_run(GTK_DIALOG(Dialog));
			gtk_widget_destroy(Dialog);
			gdk_flush();
			gdk_threads_leave();
			if (Response == GTK_RESPONSE_CANCEL){
				Is_Iter = gtk_tree_model_iter_next(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree)), &Iterator);
				if (Is_Iter) continue;
				else g_thread_exit(NULL);
			}
			rh = smbc_open(Samba_Encoded_Path, O_RDONLY, 0644);
			if (Response == GTK_RESPONSE_OK){
				count = 0;
				if (rh > 0) wh = fopen(File_Path, "w");  
			}
			if (Response == GTK_RESPONSE_APPLY){
				if (rh > 0){
					wh = fopen(File_Path, "a");
					smbc_lseek(rh, count, SEEK_SET);
				}
			}
		}
		else{
			rh = smbc_open(Samba_Encoded_Path, O_RDONLY, 0644);
			if (rh > 0) wh = fopen(File_Path, "w");  
		}
		if (wh == NULL){
			Dialog = gtk_message_dialog_new(GTK_WINDOW(Main_Window), GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, "No such directory or permissions denide");
			gtk_message_dialog_format_secondary_text(GTK_MESSAGE_DIALOG(Dialog),  "Check '%s' directory", Save_Folder);			
			gdk_threads_enter();
			Response = gtk_dialog_run(GTK_DIALOG(Dialog));
			gtk_widget_destroy(Dialog);
			gdk_flush();
			gdk_threads_leave();
			g_thread_exit(NULL);
		}
	 	if (rh > 0){
 			gdk_threads_enter();
			gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 0, Download_Icon[1], 1, "Downloading", -1);
			gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(Downloader_Status), 0);
			gtk_progress_bar_set_text(GTK_PROGRESS_BAR(Downloader_Status), Utf8_Path);
			gdk_flush();
			gdk_threads_leave();
	 		while (TRUE){
				if ((rbyte = smbc_read(rh, rbuff, sizeof(rbuff))) > 0){
					if (fwrite(rbuff, rbyte, 1, wh) !=1){
						gdk_threads_enter();
						gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 0, Download_Icon[2], 1, "Write error", -1);
						gdk_flush();
				 		gdk_threads_leave();
						smbc_close(rh);
						fclose(wh);
				 		g_thread_exit(NULL);
					}
					else{
						count = count+rbyte;
						if (count>procent.quot*k){
							statfs(File_Path, &hdd);
							gdk_threads_enter();
							if ((hdd.f_bsize*hdd.f_bavail) < (Size-count)) gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 1, "Disk low", -1);
							else gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 1, "Downloading", -1);
							gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(Downloader_Status), k*0.01);
							gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 2, k, -1);
							gdk_flush();
							gdk_threads_leave();
							k++;
						}	
						if (count == Size){
							smbc_close(rh);
							fclose(wh);
							gdk_threads_enter();
							gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(Downloader_Status), 0);
							gtk_progress_bar_set_text(GTK_PROGRESS_BAR(Downloader_Status), "Finished");
							gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 0, Download_Icon[3], 1, "OK", 2,  100, -1);
							gdk_flush();
							gdk_threads_leave();
							break;
						}
					}
					if (Download_Flag == FALSE){
						gdk_threads_enter();
						gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 0, Download_Icon[2], 1, "Terminated", -1);
						gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(Downloader_Status), 0);
						gtk_progress_bar_set_text(GTK_PROGRESS_BAR(Downloader_Status), "Stopped");
						gdk_flush();
			 			gdk_threads_leave();
						smbc_close(rh);
						fclose(wh);
			 			g_thread_exit(NULL);
	 				} 
				}
				else{
					smbc_close(rh);
					if ((rh = smbc_open(Samba_Encoded_Path, O_RDONLY, 0666)) > 0){
					 	smbc_lseek(rh, count, SEEK_SET);
					}	
					else{
						gdk_threads_enter();
						gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 0, Download_Icon[2], 1, "Source unreachable", -1);
						gdk_flush();
				 		gdk_threads_leave();
				 		break;
					} 
				}
			}
	 	}
	 	else{
			gdk_threads_enter();
			gtk_tree_store_set(GTK_TREE_STORE(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree))), &Iterator, 0, Download_Icon[2], 1, "Coudn't open", -1);
			gdk_flush();
	 		gdk_threads_leave();
	 	}
		Is_Iter = gtk_tree_model_iter_next(gtk_tree_view_get_model(GTK_TREE_VIEW(Download_Tree)), &Iterator);
	}
	return NULL;
}

gboolean Filter(gchar *Filtering_Type, gchar *Filtering_Item)
{
	gint Active;
	gint Min, Max;
	gchar Filter_String[128], *Ext;
	
	Active = gtk_combo_box_get_active(GTK_COMBO_BOX(Selecter));
	Filtering_Item = g_filename_to_utf8(Filtering_Item, -1, NULL, NULL, NULL);
	Filtering_Item = g_utf8_strdown (Filtering_Item, -1);

	if (Filtering_Type == "FILTER_BY_EXT"){
		strcpy(Filter_String, Masks[Active].Extensions);
		Ext = strrchr(Filtering_Item, '.');
		Ext = strtok(Ext, ".");
		if (Ext != NULL){
			if (strstr(Filter_String, Ext) != NULL) return TRUE;
		}
	}
	if (Filtering_Type == "FILTER_BY_SHARE"){
		strcpy(Filter_String, Masks[Active].Shares);
		Ext = strtok(Filter_String, ",");
		while (Ext != NULL){
			if (strstr(Filtering_Item, Ext) != NULL) return TRUE;
			Ext = strtok(NULL, ",");
		}
	}
	if (Filtering_Type == "FILTER_BY_SIZE"){
		Min=atoi(Masks[Active].MinSize);
		Max=atoi(Masks[Active].MaxSize);
		if (strcmp(Masks[Active].Metric, "KB") == 0){
			Min = Min*1024;
			Max = Max*1024;
		}
		if (strcmp(Masks[Active].Metric, "MB") == 0){
			Min = Min*1024*1024;
			Max = Max*1024*1024;
		}
		if ((atoi(Filtering_Item)>=Min) && (atoi(Filtering_Item)<=Max)) return TRUE;
	}
	return FALSE;
}
